namespace CMSMicroservice.Application.ProductCategoryCQ.Commands.CreateNewProductCategory;
public class CreateNewProductCategoryCommandValidator : AbstractValidator<CreateNewProductCategoryCommand>
{
    public CreateNewProductCategoryCommandValidator()
    {
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.CategoryId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewProductCategoryCommand>.CreateWithOptions((CreateNewProductCategoryCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
